/**
This file is part of Gel2DE.

    Gel2DE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Gel2DE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Gel2DE.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2012, University of Bergen
*/

#pragma once

#include "tinyxml.h"
#include "itkScalableAffineTransform.h"

class GelImageTransformation
{
public:
	GelImageTransformation(TiXmlElement*);
	~GelImageTransformation(void);

	typedef itk::ScalableAffineTransform<double, 2> TransformType;

	TransformType::MatrixType getMatrix();
	TransformType::OffsetType getOffset();

private:
	TransformType::MatrixType m_Matrix;
	TransformType::OffsetType m_Offset;

};
