/**
This file is part of Gel2DE.

    Gel2DE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Gel2DE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Gel2DE.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2012, University of Bergen
*/

#pragma once

#include "File.h"
#include "tinyxml.h"

class ProjectConfiguration
{
public:
	ProjectConfiguration(void);
	~ProjectConfiguration(void);

	void FromXML(std::string aFileName);
	void ToXML(std::string aFileName, std::vector<std::string*>* aExcludedFiles);
	gel2de::File* getDataDir();
	gel2de::File* getOutputDataDir();
	gel2de::File* getParameterFile();
	gel2de::File* getRegistrationFile();
	gel2de::File* getCtfFile();
	std::string getProjectFile();
	void Clear();
	bool Is8Bit();

	std::vector<std::string*>* getExcludedFilesStoredInProject();

private:
	gel2de::File* m_DataDir;
	gel2de::File* m_OutputDataDir;
	gel2de::File* m_ParameterFile;
	gel2de::File* m_RegistrationFile;
	gel2de::File* m_ctfFile;
	
	std::string m_currentFile;
	std::vector<std::string*>* m_excludedFiles;
	bool m_8bit;

};
