/**
This file is part of Gel2DE.

    Gel2DE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Gel2DE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Gel2DE.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2012, University of Bergen
*/

#pragma once
#include<iostream>

class SpearmanRankElement
{
public:
	SpearmanRankElement(double, double);
	~SpearmanRankElement(void);

	const static int X = 0;
	const static int Y = 1;

	const double GetValue(const int) const;
	const float GetRank(const int) const;
	void SetRank(int, float);

private:
	const float GetRankX() const;
	const float GetRankY() const;
	void SetRankX(float);
	void SetRankY(float);
	const double GetValueX() const;
	const double GetValueY() const;

	double m_x;
	double m_y;
	float m_R;
	float m_S;
};
